use crate::game::*;
use std::fmt;

#[derive(Copy, Clone, Eq, PartialEq, Debug)]
pub enum BinaryPlayer {
    X,
    O,
}

impl fmt::Display for BinaryPlayer {
    fn fmt(&self, formatter: &mut fmt::Formatter) -> fmt::Result {
        formatter.write_str(match self {
            Self::X => "X",
            Self::O => "O",
        })
    }
}

impl GamePlayer for BinaryPlayer {
    fn first() -> Self {
        Self::X
    }
    fn next(&self) -> Self {
        match self {
            Self::X => Self::O,
            Self::O => Self::X,
        }
    }
}
